src/waves/accounts/urls.py
from __future__ import unicode_literals
from django.conf.urls import include, url
from django.views.generic import TemplateView

import waves.views.accounts

urlpatterns = [
    url(r'^activate/complete/$',
        waves.views.accounts.ActivationView.as_view(template_name='accounts/activation_complete.html'),
        name='registration_activation_complete'),
    url(r'^activate/(?P<activation_key>[-:\w]+)/$',
        waves.views.accounts.ActivationView.as_view(),
        name='registration_activate'),
    url(r'^register/$',
        waves.views.accounts.SignUpView.as_view(),
        name='registration_register'),
    url(r'^register/complete/$',
        TemplateView.as_view(template_name='accounts/registration_complete.html'),
        name='registration_complete'),
    url(r'^register/closed/$',
        TemplateView.as_view(template_name='accounts/registration_closed.html'),
        name='registration_disallowed'),
    url(r'^login/$', waves.views.accounts.LoginView.as_view(), name="login"),
    url(r'^logout/$', waves.views.accounts.LogoutView.as_view(), name='logout'),
    url(r'^signup/$', waves.views.accounts.SignUpView.as_view(), name='signup'),
    url(r'^password/change/$', waves.views.accounts.PasswordChangeView.as_view(), name='password-change'),
    url(r'^password/reset/$', waves.views.accounts.PasswordResetView.as_view(), name='password-reset'),
    url(r'^password/reset/done/$', waves.views.accounts.PasswordResetDoneView.as_view(), name='password-reset-done'),
    url(r'^password/reset/(?P<uidb64>[0-9A-Za-z_\-]+)/(?P<token>[0-9A-Za-z]{1,13}-[0-9A-Za-z]{1,20})/$$',
        waves.views.accounts.PasswordResetConfirmView.as_view(),
        name='password-reset-confirm'),
]

src/waves/profiles/urls.py
from __future__ import unicode_literals
from django.conf.urls import url
import waves.views.profiles

urlpatterns = [
    url(r'^me$', waves.views.profiles.ShowProfile.as_view(), name='show_self'),
    url(r'^me/edit$', waves.views.profiles.EditProfile.as_view(), name='edit_self'),
    url(r'^(?P<slug>[\w\-]+)$', waves.views.profiles.ShowProfile.as_view(),
        name='show'),
]

src/waves/urls/urls.py
from __future__ import unicode_literals

from django.conf.urls import url
from django.conf.urls import include
from waves.views.base import *

urlpatterns = [
    url(r'^$', HomePage.as_view(), name='home'),
    url(r'^accounts/', include('waves.urls.accounts_url')),
    url(r'^api/', include('waves.urls.api_urls')),
    url(r'^admin/', include('waves.urls.back_urls')),
    url(r'^waves/', include('waves.urls.front_urls'))
]

src/waves_services/urls.py
from __future__ import unicode_literals

from django.conf import settings
from django.conf.urls import include, url
from django.conf.urls.static import static
from django.contrib import admin

urlpatterns = [
    url(r'^', include('waves.urls.urls', namespace='waves')),
    url(r'^nested_admin/', include('nested_admin.urls')),
    url(r'^grappelli/', include('grappelli.urls')),  # grappelli URLS
    url(r'^admin/', include(admin.site.urls)),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

src/waves/models/samples.py
from __future__ import unicode_literals
from django.db import models


def service_sample_directory(instance, filename):
    return 'sample/{0}/{1}'.format(instance.service.api_name, filename)


class ServiceInputSample(models.Model):
    class Meta:
        ordering = ['name']
        db_table = 'waves_service_sample'
        unique_together = ('name', 'input', 'service')

    name = models.CharField('File name', max_length=200, null=False)
    file = models.FileField('File path', upload_to=service_sample_directory, null=True, blank=True)
    input = models.ForeignKey('BaseInput', on_delete=models.CASCADE, related_name='input_samples',
                              help_text='Associated input')
    service = models.ForeignKey('Service', on_delete=models.CASCADE, related_name='services_sample', null=True)
    dependent_input = models.ForeignKey('ServiceInput',
                                        on_delete=models.SET_NULL, null=True, blank=True,
                                        help_text='Dependent on another input value')
    when_value = models.CharField('Depending on input value', max_length=255, null=True, blank=True,
                                  help_text='For dependency, related value')

src/waves/api/views/categories.py
from __future__ import unicode_literals

from rest_framework import viewsets

from waves.models import ServiceCategory
from waves.api.serializers import CategorySerializer
from . import WavesBaseView


class CategoryViewSet(viewsets.ReadOnlyModelViewSet, WavesBaseView):
    """
    API entry point to list services categories
    """
    queryset = ServiceCategory.objects.all()
    serializer_class = CategorySerializer
    lookup_field = 'name'

src/waves/api/views/jobs.py
from __future__ import unicode_literals
import logging

from django.shortcuts import get_object_or_404
from rest_framework import viewsets, mixins
from rest_framework.parsers import MultiPartParser, JSONParser
from rest_framework.response import Response
from rest_framework.decorators import detail_route, list_route

from waves.models import Job
from waves.api.serializers.jobs import JobSerializer, JobHistoryDetailSerializer, \
    JobInputDetailSerializer, JobOutputDetailSerializer
from . import WavesBaseView

logger = logging.getLogger(__name__)


class JobViewSet(mixins.ListModelMixin, mixins.RetrieveModelMixin, mixins.DestroyModelMixin,
                 viewsets.GenericViewSet, WavesBaseView):
    """
    API entry point for ServiceJobs
    """
    queryset = Job.objects.all()
    serializer_class = JobSerializer
    parser_classes = (MultiPartParser, JSONParser)
    lookup_field = 'slug'

    def get_queryset(self):
        return Job.objects.all()

    def list(self, request, *args, **kwargs):
        queryset = Job.objects.get_user_job(user=request.user)
        serializer = JobSerializer(queryset,
                                   many=True,
                                   context={'request': request},
                                   fields=('url', 'created', 'status', 'service'))
        return Response(serializer.data)

    def retrieve(self, request, slug=None, *args, **kwargs):
        queryset = Job.objects.get_user_job(user=request.user)
        service_job = get_object_or_404(queryset,
                                        slug=slug)
        serializer = JobSerializer(service_job,
                                   context={'request': request})
        return Response(serializer.data)

    def destroy(self, request, slug=None, *args, **kwargs):
        queryset = Job.objects.get_user_job(user=request.user)
        service_job = get_object_or_404(queryset, slug=slug)
        return Response(self.get_serializer(request=request).data)

    def update(self, request, slug=None):
        return Response(self.get_serializer(request=request).data)

    def partial_update(self, request, slug=None):
        return Response(self.get_serializer(request=request).data)

    @detail_route(methods=['get'], url_path='history')
    def list_history(self, request, slug=None):
        queryset = Job.objects.get_user_job(user=request.user)
        job = get_object_or_404(queryset, slug=slug)
        serializer = JobHistoryDetailSerializer(job,
                                                many=False,
                                                context={'request': request})
        return Response(serializer.data)

    @detail_route(methods=['get'], url_path='inputs')
    def list_inputs(self, request, slug=None):
        queryset = Job.objects.get_user_job(user=request.user)
        job = get_object_or_404(queryset, slug=slug)
        serializer = JobInputDetailSerializer(job,
                                              many=False,
                                              context={'request': request})
        return Response(serializer.data)

    @detail_route(methods=['get'], url_path='outputs')
    def list_outputs(self, request, slug=None):
        queryset = Job.objects.get_user_job(user=request.user)
        job = get_object_or_404(queryset, slug=slug)
        serializer = JobOutputDetailSerializer(job,
                                               many=False,
                                               context={'request': request})
        return Response(serializer.data)

src/waves/api/views/services.py
from __future__ import unicode_literals
from django.shortcuts import get_object_or_404
from rest_framework import viewsets, permissions
from rest_framework.response import Response
from rest_framework import status
from rest_framework.decorators import detail_route, list_route

from waves.models import Service, ServiceInput, Job
from waves.exceptions import JobException
from waves.api.serializers import InputSerializer, ServiceSerializer, ServiceJobSerializer, JobSerializer
from . import WavesBaseView

import logging

logger = logging.getLogger(__name__)


class ServiceInputViewSet(viewsets.ReadOnlyModelViewSet, WavesBaseView):
    """
    Api entry point to ServiceInputs
    """
    serializer_class = InputSerializer

    def get_queryset(self):
        return ServiceInput.objects.filter(tool__pk=self.kwargs['service'],
                                           conditionalqsdqsdinput=None,
                                           conditionalwhen=None)


class ServiceViewSet(viewsets.ReadOnlyModelViewSet, WavesBaseView):
    """
    API entry point to Services
    """
    serializer_class = ServiceSerializer
    lookup_field = 'api_name'

    def get_queryset(self):
        return Service.objects.get_public_services()

    def list(self, request):
        queryset = Service.objects.get_public_services()
        serializer = ServiceSerializer(queryset, many=True, context={'request': request},
                                       fields=('url', 'name', 'short_description', 'version', 'created', 'updated',
                                               'category', 'jobs')
                                       )
        return Response(serializer.data)

    def retrieve(self, request, api_name=None):
        queryset = Service.objects.get_public_services()
        service_tool = get_object_or_404(queryset, api_name=api_name)
        serializer = ServiceSerializer(service_tool, context={'request': request})
        return Response(serializer.data)

    @detail_route(methods=['post', 'get'], url_path='jobs')
    def service_job(self, request, api_name=None):
        if request.POST:
            # CREATE A NEW JOB
            if logger.isEnabledFor(logging.DEBUG):
                for param in request.data:
                    logger.debug('param key ' + param)
                    logger.debug(request.data[param])
                logger.debug('Request Data %s', request.data)
            queryset = Service.objects.get_public_services()
            service = get_object_or_404(queryset, api_name=api_name)
            ass_email = request.data.pop('email', None)
            try:
                request.data.pop('api_key')
                submitted_data = {
                    'service': service.pk,
                    'client': request.user.pk,
                    'inputs': request.data
                }
                # serializer = ServiceJobSerializer(many=False, context={'request': request},data=request.data)
                serializer = self.get_serializer(context={'request': request},
                                                 fields=('inputs',))
                serializer.run_validation(data=submitted_data,)
                job = Service.objects.create_new_job(service=service,
                                                     email_to=ass_email,
                                                     submitted_inputs=request.data,
                                                     user=request.user)
                serializer = JobSerializer(job,
                                           many=False,
                                           context={'request': request},
                                           fields=('slug', 'url', 'created', 'status',))
                return Response(serializer.data, status=201)
            except JobException as e:
                logger.fatal("Create Error %s", e.message)
                return Response({'error': e.message}, status=status.HTTP_400_BAD_REQUEST)
        else:
            # RETRIEVE A SERVICE JOB
            queryset = Service.objects.get_public_services()
            service_tool = get_object_or_404(queryset, api_name=api_name)
            queryset_jobs = Job.objects.get_service_job(user=request.user, service=service_tool)
            serializer = JobSerializer(queryset_jobs,
                                       many=True,
                                       context={'request': request},
                                       fields=('url', 'created', 'status', 'service'))
            return Response(serializer.data)


class ServiceJobViewSet(WavesBaseView):
    serializer_class = ServiceJobSerializer
    pass

src/waves/views/base.py
from __future__ import unicode_literals
from django.views import generic


class HomePage(generic.TemplateView):
    template_name = "home.html"


class AboutPage(generic.TemplateView):
    template_name = "about.html"

src/waves/views/files.py
from __future__ import unicode_literals

import os

from django.views import generic
from django.http import HttpResponse
from django.utils.encoding import smart_str

from wsgiref.util import FileWrapper


class DownloadFileView(generic.DetailView):
    template_name = 'services/file.html'
    context_object_name = 'file'
    slug_field = 'slug'
    http_method_names = ['get', ]

    def __init__(self, **kwargs):
        super(DownloadFileView, self).__init__(**kwargs)

    def render_to_response(self, context, **response_kwargs):
        """
            Creates a response with file asked, otherwise returns displayed file as 'Text'
            template response.
            """
        # Sniff if we need to return a CSV export
        if 'export' in self.request.GET:
            wrapper = FileWrapper(file(self.file_path))
            response = HttpResponse(wrapper, content_type='application/force-download')
            response['Content-Disposition'] = 'attachment; filename="' + self.file_name + '"'
            response['X-Sendfile'] = smart_str(self.file_path)
            response['Content-Length'] = os.path.getsize(self.file_path)
            return response
        else:
            return super(DownloadFileView, self).render_to_response(context, **response_kwargs)

    def get_context_data(self, **kwargs):
        context = super(DownloadFileView, self).get_context_data(**kwargs)
        if 'export' not in self.request.GET:
            with open(self.file_path) as fp:
                context['file_content'] = fp.read()
            context['return_link'] = self.return_link
            context['file_description'] = self.file_description
            context['file_name'] = self.file_name
        return context

    @property
    def return_link(self):
        return "#"

    @property
    def file_description(self):
        return ""

    @property
    def file_name(self):
        return "Fake.txt"

    @property
    def file_path(self):
        return "/dev/null"

src/waves/views/jobs.py
from __future__ import unicode_literals

import logging

from django.contrib.auth.decorators import login_required
from django.utils.decorators import method_decorator
from django.views import generic

from waves.models import Job, JobOutput, JobInput
from waves.views.files import DownloadFileView

logger = logging.getLogger(__name__)


class JobView(generic.DetailView):
    model = Job
    slug_field = 'slug'
    template_name = 'services/job_detail.html'
    context_object_name = 'job'

    def dispatch(self, request, *args, **kwargs):
        return super(JobView, self).dispatch(request, *args, **kwargs)


class JobListView(generic.ListView):
    model = Job
    template_name = 'services/job_list.html'
    context_object_name = 'job_list'

    @method_decorator(login_required)
    def dispatch(self, request, *args, **kwargs):
        return super(JobListView, self).dispatch(request, *args, **kwargs)

    def get_queryset(self):
        return Job.objects.get_user_job(user=self.request.user)


class JobFileView(DownloadFileView):
    context_object_name = "file_obj"

    @property
    def file_name(self):
        return self.object.value

    @property
    def file_path(self):
        return self.object.file_path

    @property
    def return_link(self):
        return self.object.job.get_absolute_url()


class JobOutputView(JobFileView):
    model = JobOutput

    @property
    def file_description(self):
        return self.object.srv_output.short_description if self.object.srv_output else self.object.value


class JobInputView(JobFileView):
    model = JobInput

    @property
    def file_name(self):
        return self.object.srv_input.label if self.object.srv_input else self.object.value

    @property
    def file_description(self):
        return self.object.srv_input.short_description if self.object.srv_input else self.object.value

src/waves/templates/_brandname.html
WAVES

src/waves/templates/_cite.html
<div class="panel panel-default">
    <div class="panel-heading">
        <h3 class="panel-title">
            If you desire to cite our work please use this reference
        </h3>
    </div>
    <div class="panel-body">
    Chakiachvili, M. et al., 2016. WAVES: a Web Application for Versatile Evolutionary bioinformatic Services.
    <br/>In JOBIM 2016. Lyon
    <br/>Available at: <a href="http://waves.atgc-montpellier.fr">http://waves.atgc-montpellier.fr</a>
    </div>
</div>

src/waves/templates/_navbar.html
<li {% if active_link == "home" %}class="active"{% endif %}><a href="{% url 'waves:home' %}">Home</a></li>
<li {% if active_link == "services" %}class="active"{% endif %}><a href="{% url 'waves:services_list' %}">Online
    services</a></li>
<li {% if active_link == "rest_api" %}class="active"{% endif %}><a href="{% url 'waves:rest_services' %}">REST Access</a>
</li>
<li {% if active_link == "about" %}class="active"{% endif %}><a href="{% url 'waves:about' %}">About</a></li>

src/waves/templates/about.html
{% extends "base.html" %}

{% load staticfiles %}
{% load crispy_forms_tags %}

{% block title %}{{ block.super }}About{% endblock %}

{% block navbar-left %}
    {% include "_navbar.html" with active_link="about" %}
{% endblock %}

<!-- Benefits of the Django application -->
{% block container %}

    <div id="sec1" class="text-page">
        <div class="container">
            <div class="row">
                <div class="col-md-12 text-center">
                    <h1>{% include "_brandname.html" %}</h1>
                    <p class="lead">Web Application for Versatile Evolutionary bioinformatic Services</p>
                </div>
            </div>
        </div>
    </div>

    <div id="sec2" class="text-page">
        <div class="container">
            <div class="row">
                <div class="col-md-12 text-center">
                    {% include '_cite.html' %}
                </div>
            </div>
            <div class="row">
                <div class="col-md-12 text-center">
                    <h2>Partners</h2>
                    <p class="lead">The Wonderful People Behind the Site</p>
                </div>
            </div>
            <div class="row">
                <div class="col-lg-12">
                    <div class="row">
                        <div class="col-lg-4">
                            <img src="{% static "site/logos/lirmm.png" %}" class="img-responsive center-block"
                                 style="max-height:100px">
                            <hr/>
                            <p class="text-justify">The Montpellier Laboratory of Informatics, Robotics and
                                Microelectronics LIRMM) is
                                attached to Montpellier University and the French National Center for Scientic
                                Research (CNRS). Its activity is developed within three scientific research
                                departments (Informatics, Microelectronics, Robotics), 19 team-projects and several
                                common services.</p>

                        </div>
                        <div class="col-lg-4">
                            <img src="{% static "site/logos/cnrs.png" %}" class="img-responsive center-block"
                                 style="max-height:100px">
                            <hr/>
                            <p class="text-justify">The National Center for Scientific Research, or CNRS, is a
                                public organization under
                                the responsibility of the French Ministry of Education and Research.
                            </p>

                        </div>
                        <div class="col-lg-4">
                            <img src="{% static "site/logos/ifb.png" %}" class="img-responsive center-block"
                                 style="max-height:100px">
                            <hr/>
                            <p class="text-justify">The French Institute of Bioinformatics (referred to as IFB
                                hereafter) is a national
                                service infrastructure in bioinformatics that was created following the call for
                                proposals, “National Infrastructures in Biology and Health”, of the “Investments for
                                the Future” initiative.</p>

                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div id="sec3">
        <div class="container">
            <div class="row">
                <div id="map-outer" class="col-md-12">
                    <div id="address" class="col-md-4">
                        <h2>Laboratory</h2>
                        <address>
                            <strong>LIRMM - Laboratoire d'Informatique, de Robotique et de Microélectronique de
                                Montpellier</strong><br>
                            Université Montpellier <br/>
                            Campus St Priest,<br/>
                            161 Rue Ada<br/>
                            34090 Montpellier<br/>
                            <abbr>P:</abbr> 04 67 41 85 85<br/>
                            <abbr>W:</abbr> <a href="http://www.lirmm.fr" target="_blank">Web site</a>
                        </address>
                    </div>
                    <div id="map-container" class="col-md-8"></div>
                </div>
            </div>
        </div>
    </div>
{% endblock container %}
{% block footer %}
{% endblock %}
{% block scripts %}
    <script src="http://maps.google.com/maps/api/js?sensor=false"></script>
    <script>

        function init_map() {
            // Enter the latitude and longitude of your office here
            var myLocation = new google.maps.LatLng(43.637336, 3.840560);

            var mapOptions = {
                center: myLocation,
                zoom: 15
            };

            var marker = new google.maps.Marker({
                position: myLocation,
                title: "LIRMM Office"
            });

            var map = new google.maps.Map(document.getElementById("map-container"),
                    mapOptions);
            marker.setMap(map);
        }

        google.maps.event.addDomListener(window, 'load', init_map);
    </script>
{% endblock scripts %}

src/waves/templates/base.html
<!DOCTYPE html>
<html lang="en">
{% load staticfiles bootstrap_themes %}
{% load thumbnail %}
<head>
    <meta charset="utf-8"/>
    <meta http-equiv="X-UA-Compatible" content="IE=edge"/>
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
    <meta name="description" content="{% block description %}{% endblock description %}"/>
    <meta name="author" content="Marc Chakiachvili"/>
    <link rel="shortcut icon" href="{% static 'site/ico/favicon.ico' %}" type="image/x-icon"/>

    <title>{% block title %} :: {% include "_brandname.html" %} :: {% endblock %}</title>

    <!-- Bootstrap core CSS -->
    {% bootstrap_styles theme=BOOTSTRAP_CSS_THEME type='css' %}
    <!-- Custom styles for this site -->
    {% block styles %}
        <link href="{% static 'site/css/main.css' %}" rel="stylesheet"/>
    {% endblock styles %}

    <!-- Custom tags for the head tag -->
    {% block extrahead %}{% endblock extrahead %}

    <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
    <!--[if lt IE 9]>
      <script src="https://oss.maxcdn.com/libs/html5shiv/3.7.0/html5shiv.js"></script>
      <script src="https://oss.maxcdn.com/libs/respond.js/1.3.0/respond.min.js"></script>
    <![endif]-->
</head>

<body>

{% block navbar %}
    <div class="navbar navbar-default navbar-fixed-top" role="navigation">
        <div class="navbar-header">
            <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                <span class="sr-only">Toggle navigation</span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
            </button>
            <a class="navbar-brand" href="{% url 'waves:home' %}">
                {% block navbar-brand %}
                    <img src="{% static 'site/logos/waves.png' %}" alt="logo" id="navbar-logo"/>
                {% endblock %}
            </a>
        </div>
        {% block navbar-menu %}
            <div class="collapse navbar-collapse">
                <ul class="nav navbar-nav">
                    {% block navbar-left %}{% endblock %}
                </ul>
                <ul class="nav navbar-nav navbar-right">
                    {% block navbar-right %}
                        {% if user.is_authenticated %}
                            {% if user.is_staff %}
                                <li><a href="{% url 'admin:index' %}">Admin</a></li>
                            {% endif %}
                            <li class="dropdown">
                                <a href="#" class="dropdown-toggle profile-menu" data-toggle="dropdown">
                                    <img src="{% thumbnail user.profile.picture|default:'default_profile.png' 30x30 crop %}"
                                         alt=""/>
                                    {{ user.get_full_name|truncatechars:20 }}
                                    <span class="caret"></span>
                                </a>

                                <ul class="dropdown-menu" role="menu">
                                    <li><a href="{% url 'waves:show_self' %}">Profile</a></li>
                                    <li><a href="{% url 'waves:logout' %}">Logout</a></li>
                                    <li><a href="{% url 'waves:job_list' %}">Your jobs</a></li>
                                </ul>
                            </li>
                        {% else %}
                            <a class="btn btn-default" href="{% url 'waves:login' %}" role="button">Log in</a>
                        {% endif %}
                    {% endblock %}
                </ul>
            </div><!--/.nav-collapse -->
        {% endblock %}
    </div>
{% endblock navbar %}

{% block messages %}
    {% if messages %}
        {% for message in messages %}
            <div class="messages alert alert-{{ message.tags }} alert-dismissible fade in">  <!-- singular -->
                <a class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span></a>
                {{ message|safe }}
            </div>
        {% endfor %}
    {% endif %}
{% endblock %}

{% block splash %}
{% endblock splash %}

{% block container %}
    <div id="sec1">
        <div class="container">
            <div class="starter-template">
                <h1>WAVES</h1>
                <p class="lead">Base Html page - or 404</p>
            </div>

        </div><!-- /.container -->
    </div>
{% endblock container %}

<!-- Site footer -->
{% block footer %}
    <div class="container">
        <div class="footer">
            <div class="row">
                <div class="col-lg-12 text-center">
                    <a name="contact" href="mailto:services@atgc-montpellier.fr">Contact</a> -
                    <a href="#" data-toggle="modal" data-target="#tosModal">Terms of Service</a>
                </div>
                <br/><br/>
            </div>
            <div class="row">
                <div class="col-lg-12">
                    <div class="row">
                        <div class="col-md-3">
                            <div class="thumbnail">
                                <img src="{% static "site/logos/lirmm.png" %}" class="img-responsive"
                                     style="max-height:100px">
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="thumbnail">
                                <img src="{% static "site/logos/cnrs.png" %}" class="img-responsive"
                                     style="max-height:100px">
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="thumbnail">
                                <img src="{% static "site/logos/ifb.png" %}" class="img-responsive"
                                     style="max-height:100px">
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="thumbnail">
                                <img src="{% static "site/logos/um.png" %}" class="img-responsive"
                                     style="max-height:100px">
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
{% endblock %}
{% block modalcontent %}
    {% include 'tos/tos_modal.html' %}
{% endblock modalcontent %}
<script type="text/javascript" src="http://cdnjs.cloudflare.com/ajax/libs/jquery/2.2.3/jquery.min.js"></script>
{% bootstrap_script use_min=True %}
<script type="text/javascript"
        src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.10.0/js/bootstrap-select.min.js"></script>
{% block scripts %}
    <script src="{% static 'site/js/site.js' %}"></script>
{% endblock scripts %}
</body>
</html>